# Generated by Django 4.2.5 on 2023-12-13 12:57

from django.conf import settings
import django.contrib.gis.db.models.fields
from django.db import migrations, models
import django.db.models.deletion
import imagekit.models.fields
import openbook_appointments.helpers
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("openbook_communities", "0035_alter_communityinvite_creator"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="VideoCallLink",
            fields=[
                ("id", models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ("url", models.URLField(max_length=500)),
                ("additional_info", models.TextField(blank=True, max_length=100, null=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Appointment",
            fields=[
                ("id", models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                ("title", models.CharField(max_length=40)),
                ("invite_only", models.BooleanField(default=True)),
                ("start_date_time", models.DateTimeField()),
                ("end_date_time", models.DateTimeField()),
                ("location", models.CharField(blank=True, db_index=True, max_length=192, null=True)),
                ("geolocation", django.contrib.gis.db.models.fields.PointField(blank=True, null=True, srid=4326)),
                ("description", models.TextField(blank=True, max_length=600)),
                (
                    "thumbnail",
                    imagekit.models.fields.ProcessedImageField(
                        blank=True,
                        max_length=500,
                        null=True,
                        upload_to=openbook_appointments.helpers.upload_to_space_appointment_thumbnail_directory,
                        verbose_name="thumbnail",
                    ),
                ),
                ("thumbnail_blurhash", models.CharField(blank=True, max_length=50, null=True)),
                (
                    "permission",
                    models.CharField(
                        choices=[("PARTICIPANTS", "Participants"), ("ADMINS", "Admins")],
                        default="PARTICIPANTS",
                        max_length=12,
                    ),
                ),
                (
                    "creator",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="created_appointments",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
                ("participants", models.ManyToManyField(related_name="appointments", to=settings.AUTH_USER_MODEL)),
                (
                    "space",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="appointments",
                        to="openbook_communities.community",
                    ),
                ),
                (
                    "video_call_link",
                    models.OneToOneField(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="appointment",
                        to="openbook_appointments.videocalllink",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
