# Generated by Django 4.2.5 on 2024-02-20 15:02

from django.db import migrations, models
import django.db.models.deletion
import openbook_common.validators
import uuid


class Migration(migrations.Migration):
    dependencies = [
        ("openbook_common", "0002_linkpreview"),
        ("openbook_insights", "0008_insight_openbook_in_date_pu_429df6_idx"),
    ]

    operations = [
        migrations.CreateModel(
            name="Recommendation",
            fields=[
                ("id", models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                (
                    "category",
                    models.CharField(
                        choices=[
                            ("ARTICLE", "Article"),
                            ("VIDEO", "Video"),
                            ("AUDIO", "Audio"),
                            ("SOCIAL_MEDIA", "Social Media"),
                            ("POST", "Post"),
                            ("STUDY", "Study"),
                            ("DONATION_PROJECT", "Donation Project"),
                            ("VOLUNTEERING", "Volunteering"),
                            ("TIP", "Tip"),
                            ("SPACE", "Space"),
                            ("EVENT", "Event"),
                        ],
                        max_length=255,
                    ),
                ),
                ("link", models.URLField(validators=[openbook_common.validators.url_safety_validator])),
                ("comment", models.TextField()),
                (
                    "insight",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="recommendations",
                        to="openbook_insights.insight",
                    ),
                ),
                (
                    "link_preview",
                    models.ForeignKey(
                        null=True, on_delete=django.db.models.deletion.SET_NULL, to="openbook_common.linkpreview"
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
