# Generated by Django 4.1.3 on 2023-01-09 10:40

from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):

    dependencies = [
        ("openbook_communities", "0011_communitymembershiprequest_and_more"),
        ("openbook_notifications", "0003_alter_notification_notification_type_and_more"),
    ]

    operations = [
        migrations.AlterField(
            model_name="notification",
            name="notification_type",
            field=models.CharField(
                choices=[
                    ("PR", "Post Reaction"),
                    ("PC", "Post Comment"),
                    ("PCR", "Post Comment Reply"),
                    ("PCRA", "Post Comment Reaction"),
                    ("CR", "Connection Request"),
                    ("CA", "Connection Accepted"),
                    ("CC", "Connection Confirmed"),
                    ("F", "Follow"),
                    ("FR", "Follow request"),
                    ("FRA", "Follow request approved"),
                    ("CMR", "Community membership request"),
                    ("CMRA", "Community membership approved"),
                    ("CI", "Community Invite"),
                    ("PUM", "Post user mention"),
                    ("PCUM", "Post comment user mention"),
                    ("CNP", "New post in community"),
                    ("UNP", "New post by user"),
                ],
                max_length=5,
            ),
        ),
        migrations.CreateModel(
            name="CommunityMembershipRequestNotification",
            fields=[
                ("id", models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                (
                    "membership_request",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="openbook_communities.communitymembershiprequest",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="CommunityMembershipApprovedNotification",
            fields=[
                ("id", models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False)),
                (
                    "community",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to="openbook_communities.community",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
